clear all
capture log close
set more off

#delimit ;

global d=1;


if $d==1 {;
	global data "/Users/Jess/Dropbox/Malawi/malawi_db/UndoingCommitment/data/";
	global out "/Users/Jess/Dropbox/Malawi/malawi_db/UndoingCommitment/results/replication/";
	};




use "${data}GGSY_data.dta", clear;


;;;
* TABLE 3: ALLOCATIONS TO LATER ;;;
;;;

foreach r in 10 25 50 75 100 {;
	gen c_n_late`r'_corner=0;
	replace c_n_late`r'_corner=1 if c_n_late`r'==0 | c_n_late`r'==(1+`r'/100)*100*20;
	tab c_n_late`r'_corner;
	};
	
replace c_n_late10_corner=1 if c_n_late10==2200;
	
foreach r in 10 25 50 75 100 {;
	gen c_f_late`r'_corner=0;
	replace c_f_late`r'_corner=1 if c_f_late`r'==0 | c_f_late`r'==(1+`r'/100)*100*20;
	tab c_f_late`r'_corner;
	};
	
replace c_f_late10_corner=1 if c_f_late10==2200;

	
tabstat c_n_late10 c_n_late25 c_n_late50 c_n_late75 c_n_late100, stat(mean sd p10 p25 p50 p75 p90) col(stat);
tabstat c_n_late10_corner c_n_late25_corner c_n_late50_corner c_n_late75_corner c_n_late100_corner, stat(mean) col(stat);

tabstat c_f_late10 c_f_late25 c_f_late50 c_f_late75 c_f_late100, stat(mean sd p10 p25 p50 p75 p90) col(stat);
tabstat c_f_late10_corner c_f_late25_corner c_f_late50_corner c_f_late75_corner c_f_late100_corner, stat(mean) col(stat);



foreach r in 10 25 50 75 100 {;
	gen c_n_soon`r'_corner=0;
	replace c_n_soon`r'_corner=1 if c_n_soon`r'==0 | c_n_soon`r'==(1+`r'/100)*100*20;
	tab c_n_soon`r'_corner;
	};
	
replace c_n_soon10_corner=1 if c_n_soon10==2200;
	
foreach r in 10 25 50 75 100 {;
	gen c_f_soon`r'_corner=0;
	replace c_f_soon`r'_corner=1 if c_f_soon`r'==0 | c_f_soon`r'==(1+`r'/100)*100*20;
	tab c_f_soon`r'_corner;
	};
	
replace c_f_soon10_corner=1 if c_f_soon10==2200;

	
tabstat c_n_soon10 c_n_soon25 c_n_soon50 c_n_soon75 c_n_soon100, stat(mean sd p10 p25 p50 p75 p90) col(stat);
tabstat c_n_soon10_corner c_n_soon25_corner c_n_soon50_corner c_n_soon75_corner c_n_soon100_corner, stat(mean) col(stat);

tabstat c_f_soon10 c_f_soon25 c_f_soon50 c_f_soon75 c_f_soon100, stat(mean sd p10 p25 p50 p75 p90) col(stat);
tabstat c_f_soon10_corner c_f_soon25_corner c_f_soon50_corner c_f_soon75_corner c_f_soon100_corner, stat(mean) col(stat);



****Number of consistent choices for sooner allocations;

gen num_consist_sooner=0;

foreach horizon in n f {;
	replace num_consist_sooner=num_consist_sooner+1 if c_`horizon'_soon10 <= c_`horizon'_soon25;
	replace num_consist_sooner=num_consist_sooner+1 if c_`horizon'_soon25 <= c_`horizon'_soon50;
	replace num_consist_sooner=num_consist_sooner+1 if c_`horizon'_soon50 <= c_`horizon'_soon75;
	replace num_consist_sooner=num_consist_sooner+1 if c_`horizon'_soon75 <= c_`horizon'_soon100;
	};


tab num_consist_sooner if tot_num_posdcs!=.;


gen num_consist_sooner2=0;

foreach horizon in n f {;
	replace num_consist_sooner2=num_consist_sooner2+1 if c_`horizon'_soon10 <= c_`horizon'_soon25 +100;
	replace num_consist_sooner2=num_consist_sooner2+1 if c_`horizon'_soon25 <= c_`horizon'_soon50 +100;
	replace num_consist_sooner2=num_consist_sooner2+1 if c_`horizon'_soon50 <= c_`horizon'_soon75 +100;
	replace num_consist_sooner2=num_consist_sooner2+1 if c_`horizon'_soon75 <= c_`horizon'_soon100 +100;
	};


gen num_consist_later=0;

foreach horizon in n f {;
	replace num_consist_later=num_consist_later+1 if c_`horizon'_late10 <= c_`horizon'_late25;
	replace num_consist_later=num_consist_later+1 if c_`horizon'_late25 <= c_`horizon'_late50;
	replace num_consist_later=num_consist_later+1 if c_`horizon'_late50 <= c_`horizon'_late75;
	replace num_consist_later=num_consist_later+1 if c_`horizon'_late75 <= c_`horizon'_late100;
	};	
	
	

**Generate Variables Indicating Higher Elasticities of Substitution in the Far Time Frame* ;
;

gen moreelasfar=1 if  elas_diff_average>0 & elas_diff_average~=. & fracpb_2!=.;
replace moreelasfar=0 if moreelasfar==. & elas_diff_average~=. & fracpb_2!=.;

gen moreelasfar_2=1 if  elas_diff_average>0.1 & elas_diff_average~=. & fracpb_2!=.;
replace moreelasfar_2=0 if moreelasfar_2==. & elas_diff_average~=. & fracpb_2!=.;

**Generate Variables Indicating Higher Elasticities of Substitution in the Near Time Frame*;
;

gen moreelasnear=1 if  elas_diff_average<0 & elas_diff_average~=. & fracpb_2!=.;
replace moreelasnear=0 if moreelasnear==. & elas_diff_average~=. & fracpb_2!=.;

gen moreelasnear_2=1 if  elas_diff_average<-0.1 & elas_diff_average~=. & fracpb_2!=.;
replace moreelasnear_2=0 if moreelasnear_2==. & elas_diff_average~=. & fracpb_2!=.;

label var moreelasfar "More elastic in the far horizon";
label var moreelasfar_2 "More elastic in the far horizon";
label var moreelasnear "More elastic in the near horizon";
label var moreelasnear_2 "More elastic in the near horizon";

gen fracpb_2_nonimp_ME = fracpb_2_nonimp* moreelasfar_2;



gen fracpb_2_x_target_lag_2_6=fracpb_2_nonimp*target_lag_2_6;
gen target_lag_2_6_x_MEfar=target_lag_2_6*moreelasfar_2;
gen fracpb_2_target_lag_2_6_MEfar=fracpb_2_nonimp*target_lag_2_6*moreelasfar_2;


gen fracfb_2_nonimp_ME = fracfb_2_nonimp* moreelasnear_2;

label var fracpb_2_nonimp_ME "Fraction present-biased * more elastic in the far horizon";
label var fracpb_2_x_target_lag_2_6 "Fraction present-biased * days to first disbursement < 6";
label var target_lag_2_6_x_MEfar "Days to first disbursement < 6 * more elastic in the far horizon";
label var fracpb_2_target_lag_2_6_MEfar "Fraction present-biased * more elastic in the far horizon * days to first disbursement < 6";
label var fracfb_2_nonimp_ME "Fraction future-biased * more elastic in near horizon";


;;;
* TABLE 1:  Summary statistics;;;
;;;



tabstat 
pb_all
fracpb_2
fracpb_2_nonimp
moreelasfar_2
frac_posdcs 
improreturn
,stat(N mean sd min p10 p50 p90 max) col(stat);


tabstat
male 
a1 younger middleage spouse_age_n
a4 some_primary primary morethan_primary 
havemaize relatives numinvillage
,stat(N mean sd min p10 p50 p90 max) col(stat);

tabstat
wrdrecal_1 ravens finlit_total 
wealth_bline hh_tot_bank_bline hh_cash_bline sell_items_bline sell_animals_bline exp_income_bline 
,stat(N mean sd min p10 p50 p90 max) col(stat);



tabstat
dC_1 revised_fb revised_pb
fracpb_2 fracpb_2_nonimp moreelasfar_2
frac_posdcs 
frac_sooner
target_lag
actual_lag
target_lag_2_6 improreturn 
if dC_1!=. & actual_lag!=. & actual_lag!=0, stat(N mean sd min p10 p50 p90 max) col(stat);

tabstat 
deathinfam delta_income spouse_sooner_mk
if dC_1!=. & actual_lag!=. & actual_lag!=0, stat(N mean sd min p10 p50 p90 max) col(stat);

;;;
* TABLE 2:  Number of Postive changes;;;
;;;

tab frac_posdcs;

;;;
* TABLE 4:  Determinants of Fraction Consistent or Fraction Present-biased;;;
;;;



xi: reg fracconsis_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives i.z13_month , cluster(respid);
estimates store table5_1; 
test male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives;
estadd scalar pval=r(p);           
 
xi: reg fracconsis_2 frac_posdcs moreelasfar_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives i.z13_month , cluster(respid);
estimates store table5_2;  
test frac_posdcs moreelasfar_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives;
estadd scalar pval=r(p);
 
xi: reg fracpb_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives i.z13_month , cluster(respid);
estimates store table5_3; 
test male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives;
estadd scalar pval=r(p);           

xi: reg fracpb_2 frac_posdcs moreelasfar_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives i.z13_month , cluster(respid);
estimates store table5_4;
test frac_posdcs moreelasfar_2 male younger middleage some_primary primary morethan_primary havemaize wealth_bline wrdrecal_1 ravens finlit_total relatives;
estadd scalar pval=r(p);


estout table5_* using "${out}table4.xls", replace 
		numbers label
		drop (_Iz13_month_2)
		title("Table 4.  Determinants of Fraction Consistent or Fraction Present-biased")
		collabels(, none) mlabels(, none)
		posthead("") varwidth(40) modelwidth(10)
		cells(b(star fmt(3)) se(par)) starlevels(* 0.10 ** 0.05 *** 0.001) 
		stats(N r2_a pval, fmt(0 2 2) labels("Observations" "Adjusted R-squared" "p-value")) legend 		
		postfoot("" "Note: Dependent variable is natural log of later allocation minus natural log of sooner allocation. Unit of observation is choices made by study respondents (10 choices per study respondent) that vary in time frame and rate of return for waiting; corner solutions excluded from regression sample. All allocations made in Jan-Feb 2010.") ;

estout table5_* using "${out}table4.tex", replace 
		numbers label
		drop (_Iz13_month_2)
		style(tex)
		title("Table 4.  Determinants of Fraction Consistent or Fraction Present-biased")
		collabels(, none) mlabels(, none)
		posthead("") varwidth(40) modelwidth(10)
		cells(b(star fmt(3)) se(par)) starlevels(* 0.10 ** 0.05 *** 0.001) 
		stats(N r2_a pval, fmt(0 2 2) labels("Observations" "Adjusted R-squared" "p-value")) legend 		
		postfoot("" "Note: Dependent variable is natural log of later allocation minus natural log of sooner allocation. Unit of observation is choices made by study respondents (10 choices per study respondent) that vary in time frame and rate of return for waiting; corner solutions excluded from regression sample. All allocations made in Jan-Feb 2010.") ;


;;;
* TABLE 5:  Determinants of Revisions toward Sooner ;;;
;;;

preserve;
keep if dC_1!=. & actual_lag!=. & actual_lag!=0;


xi: reg dC_1 
improreturn 
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
i.z13_month, robust;
estimates store table6_1;

xi: reg dC_1 
improreturn 
fracpb_2_nonimp target_lag_2_6 frac_sooner fracpb_2_nonimp_ME moreelasfar_2
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
i.z13_month, robust;
estimates store table6_2;

xi: reg dC_1 
improreturn 
fracpb_2_nonimp target_lag_2_6 frac_sooner fracpb_2_nonimp_ME moreelasfar_2
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
frac_posdcs wrdrecal_1 ravens finlit_total
i.z13_month, robust;
estimates store table6_3;
qui test frac_posdcs wrdrecal_1 ravens finlit_total;
estadd scalar pval=r(p);


xi: reg dC_1 
improreturn 
fracpb_2_nonimp target_lag_2_6 frac_sooner fracpb_2_nonimp_ME moreelasfar_2
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
frac_posdcs wrdrecal_1 ravens finlit_total
deathinfam delta_income
i.z13_month, robust;
estimates store table6_4;
qui test frac_posdcs wrdrecal_1 ravens finlit_total;
estadd scalar pval=r(p);

xi: reg dC_1 
improreturn 
fracpb_2_nonimp target_lag_2_6 frac_sooner fracpb_2_nonimp_ME moreelasfar_2
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
frac_posdcs wrdrecal_1 ravens finlit_total
deathinfam delta_income
spousebias_nonimp relatives
i.z13_month, robust;
estimates store table6_5;
qui test frac_posdcs wrdrecal_1 ravens finlit_total;
estadd scalar pval=r(p);

xi: reg dC_1 
improreturn 
fracpb_2_nonimp target_lag_2_6 frac_sooner fracpb_2_nonimp_ME moreelasfar_2
male younger middleage some_primary primary morethan_primary 
havemaize wealth_bline
frac_posdcs wrdrecal_1 ravens finlit_total
deathinfam delta_income
spousebias_nonimp relatives
spouse_fracpb_2 spouse_young spouse_middleage spouse_some_primary spouse_morethan_primary spouse_primary spouse_wrdrecal_1 spouse_ravens spouse_finlit_total spouse_frac_posdcs
i.z13_month, robust;
estimates store table6_6;
qui test frac_posdcs wrdrecal_1 ravens finlit_total;
estadd scalar pval=r(p);


estout table6_* using "${out}table5.xls", replace 
		numbers label
		title("Table 5.  Determinants of Revisions towards Sooner")
		collabels(, none) mlabels(, none)
		posthead("") varwidth(60) modelwidth(10)
		cells(b(star fmt(3)) se(par)) starlevels(* 0.10 ** 0.05 *** 0.001) 
		stats(N r2_a pval, fmt(0 2 2) labels("Observations" "Adjusted R-squared" "P-value for fin lit")) legend 		
		postfoot("" "Robust standard errors in parentheses. Notes: Unit of observation is individual included in revisit sample. All regressions also include the following controls: indicators for each treatments implemented in Brune, Gine, Goldberg, and Yang (2011); indicator for whether near choices were presented before far choices in baseline survey; indicator for project staff error in presentation of baseline allocation upon revisiting. Spousal characteristics controls are: fraction present biased for all choices, indicators for age category, indicators for education category, word recall, ravens score, financial literacy score, and fraction of choices adhering to law of demand.") ;

estout table6_* using "${out}table5.tex", replace 
		numbers label
		style(tex)
		title("Table 5.  Determinants of Revisions towards Sooner")
		collabels(, none) mlabels(, none)
		posthead("") varwidth(60) modelwidth(10)
		cells(b(star fmt(3)) se(par)) starlevels(* 0.10 ** 0.05 *** 0.001) 
		stats(N r2_a, fmt(0 2) labels("Observations" "Adjusted R-squared")) legend 		
		postfoot("" "Robust standard errors in parentheses. Notes: Unit of observation is individual included in revisit sample. All regressions also include the following controls: indicators for each treatments implemented in Brune, Gine, Goldberg, and Yang (2011); indicator for whether near choices were presented before far choices in baseline survey; indicator for project staff error in presentation of baseline allocation upon revisiting. Spousal characteristics controls are: fraction present biased for all choices, indicators for age category, indicators for education category, word recall, ravens score, financial literacy score, and fraction of choices adhering to law of demand.") ;


restore;

